import React, { createContext, useContext, useEffect, useState } from "react";
const initialState = {
  allTrainDiagram: undefined,
  setAllTrainDiagram: () => {},
};

const AllTrainDiagramContext = createContext(initialState);

export const useAllTrainDiagram = () => {
  return useContext(AllTrainDiagramContext);
};

export const AllTrainDiagramProvider = ({ children }) => {
  const [allTrainDiagram, setAllTrainDiagram] = useState();
  const customData = {
    //9001: "岡山,発,10:11#児島,発,11:05#坂出,発,11:41#高松,着,12:00#独自補完データ,提,https://x.com/makkun3/status/1750490886293848372#",
    9001: "ウェルカムセレモニー,頃,9:40#岡山,頃,10:10#琴平,頃,14:00#琴平観光,以降,14:00#湯山荘 阿讃琴南,頃,16:00#独自補完データ,提,https://www.the-royalexpress.jp/plan/2614/#ROYAL EXPRESS 第1章\n－瀬戸の海に想いを馳せながら－\n岡山・高松・琴平,提,https://www.the-royalexpress.jp/plan/2614/#",
    //9029: "高松,発,12:42#琴平,着,13:57#独自補完データ,提,https://x.com/makkun3/status/1750490886293848372#",
    9029: "ウェルカムセレモニー,頃,9:40#岡山,頃,10:10#琴平,頃,14:00#琴平観光,以降,14:00#湯山荘 阿讃琴南,頃,16:00#独自補完データ,提,https://www.the-royalexpress.jp/plan/2614/#ROYAL EXPRESS 第1章\n－瀬戸の海に想いを馳せながら－\n岡山・高松・琴平,提,https://www.the-royalexpress.jp/plan/2614/#",
    //9003: "多度津,発,10:09#今治,発,13:20#伊予亀岡,発,13:55#菊間,発,14:04#松山,着,14:50#独自補完データ,提,https://x.com/makkun3/status/1750490886293848372#",
    9003: "湯山荘 阿讃琴南,頃,9:00#多度津,頃,10:10#松山,頃,14:50#宿泊施設,以降,14:50#独自補完データ,提,https://www.the-royalexpress.jp/plan/2614/#ROYAL EXPRESS 第2章\n －四国の伝統文化を感じて－\n多度津・坂出・松山,提,https://www.the-royalexpress.jp/plan/2614/#",
    9055: "宿泊施設→バス,着,10:30#松山,頃,10:30#今治,頃,14:15#しまなみエリア観光,以降,14:15#Azumi Setoda,頃,16:00#独自補完データ,提,https://www.the-royalexpress.jp/plan/2614/#ROYAL EXPRESS 第3章\n－凪の誘い・瀬戸内の絶景－\n今治・しまなみ海道,提,https://www.the-royalexpress.jp/plan/2614/#",
    9056: "宿泊施設→バス,着,10:30#松山,頃,10:30#今治,頃,14:15#しまなみエリア観光,以降,14:15#Azumi Setoda,頃,16:00#独自補完データ,提,https://www.the-royalexpress.jp/plan/2614/#ROYAL EXPRESS 第3章\n－凪の誘い・瀬戸内の絶景－\n今治・しまなみ海道,提,https://www.the-royalexpress.jp/plan/2614/#",
    9004: "Azumi Setoda,頃,9:30#今治,頃,10:30#高松,頃,14:30#高松港→\n瀬戸内クルーズ（貸切）\n「おりんぴあどりーむ せと」→ \n 新岡山港,以降,14:15#岡山駅,頃,18:00#独自補完データ,提,https://www.the-royalexpress.jp/plan/2614/#ROYAL EXPRESS フィナーレ\n－四国・瀬戸内の彩りに囲まれて－\n今治・高松・岡山,提,https://www.the-royalexpress.jp/plan/2614/#",
  };
  useEffect(() => {
    fetch(
      "https://script.google.com/macros/s/AKfycbx_s7RB-xTy-iAslFJg7LfplLV09-hjDXEjdi9kCP_JT45wq17Af_IPOKIOqIfaNDg/exec"
    )
      .then((res) => res.json())
      .then((res) => {
        const data = {};
        res.forEach((d) => {
          const keys = Object.keys(d);
          data[keys] = d[keys];
        });
        return data;
      })
      .then((res) => {
        Object.assign(res, customData);
        setAllTrainDiagram(res);
      });
  }, []);

  return (
    <AllTrainDiagramContext.Provider
      value={{ allTrainDiagram, setAllTrainDiagram }}
    >
      {children}
    </AllTrainDiagramContext.Provider>
  );
};
